### Method

# Camel Session authenticate_sync

since: 3.4

#### Declaration [src]

    gboolean
    camel_session_authenticate_sync (
      CamelSession* session,
      CamelService* service,
      const gchar* mechanism,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Authenticates `service`, which may involve repeated calls to `camel_service_authenticate()` or camel_service_authenticate_sync(). A `CamelSession` subclass is largely responsible for implementing this, and should handle things like user prompts and secure password storage. These issues are out-of-scope for Camel.

If an error occurs, or if authentication is aborted, the function sets `error` and returns `FALSE`.

Available since: 3.4

#### Parameters

`service`

  Type: `CamelService`

  A `CamelService`.

  The data is owned by the caller of the method.

`mechanism`

  Type: `const gchar*`

  A SASL mechanism name, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` on success, `FALSE` on failure.